<template>
  <div class="common-page device-manage">

    <div class="option page-row">
      <!--工具栏-->
      <div class="head-container">
        <!-- 搜索 -->
        <label class="el-form-item-label" style="font-weight: 500;">信标名称</label>
        <el-input v-model="query.beaconame" clearable size="small" placeholder="请输入名称" style="width:180px;"/>
        <el-button size="mini" type="success" icon="el-icon-search" @click="toSearch">搜索</el-button>
        <el-button size="mini" icon="el-icon-refresh" @click="clearLimit">重置</el-button>
      </div>
    </div>

    <!-- 表格 -->
    <div class="panel-bottom page-row">
      <div class="ctin-box">
        <div class="content-within">
          <div class="content-fix">
            <div class="toolbar">
              <el-button size="mini" type="primary" icon="el-icon-plus" @click="toAdd">新增</el-button>
            </div>
            <div class="content">
              <el-table :data="tableData" v-loading="loading" border style="width:auto" :row-class-name="tableRowClassName">
                <el-table-column prop="beaconame" label="信标名称" align="center"></el-table-column>
                <el-table-column prop="beaconumber" label="信标编号" align="center"></el-table-column>
                <el-table-column prop="xcoordinate" label="X坐标" align="center"></el-table-column>
                <el-table-column prop="ycoordinate" label="Y坐标" align="center"></el-table-column>
                <el-table-column prop="time" label="时间" align="center"></el-table-column>
                <el-table-column label="操作" align="center" fixed="right">
                  <template slot-scope="scope">
                    <el-button size="mini" type="primary" icon="el-icon-edit" @click="toEdit(scope.row)"></el-button>
                    <el-button size="mini" type="danger" icon="el-icon-delete" @click="toDelete(scope.row)"></el-button>
                  </template>
                </el-table-column>
              </el-table>
              <!--分页组件-->
              <el-pagination :total="total" :current-page="page" style="margin-top: 8px;"
                             layout="total, prev, pager, next, sizes" @size-change="sizeChange"
                             @current-change="pageChange"/>
            </div>
          </div>
        </div>
      </div>
    </div>
    <!-- 表单渲染 -->
    <el-dialog append-to-body :close-on-click-modal="false" :before-close="cancelForm" :visible.sync="visible" :title="title" width="800px">
      <el-form :model="formData" :rules="rules" ref="formViewRef" :inline="true" :status-icon="true" size="mini">
        <el-row>
          <el-col :span="12">
            <div class="grid-content">
              <el-form-item label="信标名称：" prop="beaconame" class="form-cell">
                <div class="cell-box">
                  <el-input v-model="formData.beaconame" class="cell-input"></el-input>
                </div>
              </el-form-item>
            </div>
          </el-col>
          <el-col :span="12">
            <div class="grid-content">
              <el-form-item label="信标编号：" class="form-cell" prop="beaconumber">
                <div class="cell-box">
                  <el-input v-model="formData.beaconumber" class="cell-input"></el-input>
                </div>
              </el-form-item>
            </div>
          </el-col>
        </el-row>
        <el-row>
          <el-col :span="12">
            <div class="grid-content">
              <el-form-item label="X坐标：" class="form-cell" prop="xcoordinate">
                <div class="cell-box">
                  <el-input v-model="formData.xcoordinate" class="cell-input"></el-input>
                </div>
              </el-form-item>
            </div>
          </el-col>
          <el-col :span="12">
            <div class="grid-content">
              <el-form-item label="Y坐标：" class="form-cell" prop="ycoordinate">
                <div class="cell-box">
                  <el-input v-model="formData.ycoordinate" class="cell-input"></el-input>
                </div>
              </el-form-item>
            </div>
          </el-col>
        </el-row>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="text" @click="cancelForm">取消</el-button>
        <el-button type="primary" @click="submitForm('formViewRef', formData)">确认</el-button>
      </div>
    </el-dialog>

  </div>
</template>

<script>
import {Tools, HttpReq, Dates} from '@/assets/js/common.js';

export default {
  name: 'beacon',
  data() {
    const basePathUrl = window.basePathUrl || ''
    return {
      configUrl: basePathUrl + 'config/config.json',
      title: '新增',
      visible: false,
      loading: false,
      page: 1,
      size: 10,
      total: 0,
      query: {},
      map: null,
      graphicLayer: null,
      stuOpts: [
        {label: '全部', value: undefined},
        {label: '离线', value: '离线'},
        {label: '在线', value: '在线'},
      ],
      tableData: [],
      formData: {
        beaconame: '',
        beaconumber: '',
        xcoordinate: '',
        ycoordinate: '',
      },
      rules: {
        beaconame: {required: true, message: ' ', trigger: 'blur'},
        beaconumber: {required: true, message: ' ', trigger: 'blur'},
        xcoordinate: {required: true, message: ' ', trigger: 'blur'},
        ycoordinate: {required: true, message: ' ', trigger: 'blur'},
      },
    }
  },
  mounted() {
    this.$nextTick(() => {
      this.loadData();
    })
  },
  methods: {
    formatOpt(arr,val){
      let str='';
      arr.forEach((item)=>{
        if(item.value==val){
          str = item.label;
        }
      });
      return str;
    },
    loadData() {
      var param = this.query;
      param.page = this.page - 1;
      param.size = this.size;
      param.vague = {beaconame:param.beaconame||undefined};
      param.sort = `date,desc`;
      this.$nextTick(() => {
        //获取安检信息
        HttpReq.truckDispatching.propleGetPerbeacon(param).then((res) => {
          if (res.code == 200) {
            this.loading = false;
            this.tableData = res.body.list;
            this.total = res.body.total;
          }
        })
      })
    },
    toAdd() {
      this.title = '新增';
      this.visible = true;
    },
    toEdit(item) {
      this.title = '编辑';
      this.visible = true;
      this.formData = item;
    },
    toDelete(item) {
      var id = item.id;
      this.$confirm('确认删除该条数据吗?', '提示', {
        confirmButtonText: '确定',
        cancelButtonText: '取消',
        type: 'warning'
      }).then((e) => {
        HttpReq.truckDispatching.propleDeletePerbeacon({id}).then((res) => {
          if (res.code == 200) {
            this.$message({
              message: res.msg,
              type: 'success'
            });
            this.loadData();
          }
        })
      })
    },
    cancelForm() {
      this.visible = false;
      this.$refs.formViewRef.resetFields();
    },
    tableRowClassName({row, rowIndex}) {
    },
    // 点击搜索
    toSearch() {
      this.page = 1;
      this.loadData();
    },
    // 重置搜索
    clearLimit() {
      this.query = {};
      this.loadData()
    },
    pageChange(e) {
      this.page = e
      this.loadData()
    },
    sizeChange(e) {
      this.page = 1
      this.size = e
      this.loadData()
    },
    submitForm(validateName, item) {
      this.$refs[validateName].validate(valid => {
        if (valid) {
          if (this.title === '新增') {
            HttpReq.truckDispatching.proplePostPerbeacon(item).then((res) => {
              if (res.code == 200) {
                this.$message({
                  message: res.msg,
                  type: 'success'
                });
                this.cancelForm();
                this.loadData()
              }
            })
          } else {
            HttpReq.truckDispatching.proplePutPerbeacon(item).then((res) => {
              if (res.code == 200) {
                this.$message({
                  message: res.msg,
                  type: 'success'
                });
                this.cancelForm();
                this.loadData()
              }
            })
          }
        }
      });
    },
  },
}
</script>

<style rel="stylesheet/scss" lang="scss" scope>
.el-table .warning-row {
  background: oldlace;
}

.el-table .success-row {
  background: #f0f9eb;
}

.cell-input {
  //min-width: 220px;
}

.form-cell {
  margin: 0 !important;
  width: 100%;
}

.grid-content {
  //border: 1px solid rgba(100, 100, 100, 0.1);
  padding: 5px 30px;
}
.cell-box {
  min-width: 120px;
}
.cell-box .el-input__inner {
  border: 1px solid rgba(100, 100, 100, 0.1);
}

.cell-box .el-input.is-disabled .el-input__inner {
  border: 1px solid rgba(100, 100, 100, 0.1);
  background: white;
  cursor: text;
}

.cell-box .el-input.is-disabled .el-input__icon {
  cursor: text;
}

.cell-box .el-icon-arrow-up:before {
  content: '';
}

.mapcontainer {
  height: 30vh;
  width: 680px;
  overflow: hidden;
}
</style>
